#if !defined(__PrivIoXP_IOCTL_H__)
#define __PrivIoXP_IOCTL_H__

#define PRIVIOXP_DEVICE_BASE_NAME "PPORTIO"

#define PRIVIOXP_TYPE 40000

// Note: CTL_CODEs 0x800-0xfff reserved for developers

#define IOCTL_PRIVIOXP_READ_PORT_BASE \
    CTL_CODE(PRIVIOXP_TYPE,  0x900, METHOD_BUFFERED, FILE_READ_ACCESS)

#define IOCTL_PRIVIOXP_READ_OPEN_COUNT \
    CTL_CODE(PRIVIOXP_TYPE,  0x901, METHOD_BUFFERED, FILE_READ_ACCESS)

#define IOCTL_PRIVIOXP_READ_PORT_STATUS \
    CTL_CODE(PRIVIOXP_TYPE, 0x902, METHOD_BUFFERED, FILE_READ_ACCESS )

#define IOCTL_PRIVIOXP_WRITE_PORT_DATA \
    CTL_CODE(PRIVIOXP_TYPE,  0x903, METHOD_BUFFERED, FILE_WRITE_ACCESS)

#define IOCTL_PRIVIOXP_WRITE_PORT_CTL \
    CTL_CODE(PRIVIOXP_TYPE,  0x904, METHOD_BUFFERED, FILE_WRITE_ACCESS)


#define IOCTL_IOPM_RESTRICT_ALL_ACCESS \
    CTL_CODE(PRIVIOXP_TYPE, 0xa01, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IOPM_ALLOW_ALL_ACCESS \
    CTL_CODE(PRIVIOXP_TYPE, 0xa02, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_SET_IOPM \
    CTL_CODE(PRIVIOXP_TYPE, 0xa03, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_CLEAR_IOPM \
    CTL_CODE(PRIVIOXP_TYPE, 0xa04, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_ENABLE_IOPM_ON_PROCESSID \
    CTL_CODE(PRIVIOXP_TYPE, 0xa05, METHOD_BUFFERED, FILE_ANY_ACCESS)

#endif /* __PrivIoXP_IOCTL_H__ */

